<!--
/*
 *  Copyright 2012 by Texas Instruments Incorporated .
 *  
 */
-->

<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>Linux Utils Application Programming Interface (API): SDMA Manager</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<table width="100%">
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border="0" src="tilogo.gif" /></a></td>
  <td bgcolor="red"><img src="titagline.gif" /></td>
</tr>
</table>
<!-- Generated by Doxygen 1.7.2 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li id="searchli">
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#define-members">Defines</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<h1>SDMA Manager</h1>  </div>
</div>
<div class="contents">
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_s_d_m_a__transfer_state.html">SDMA_transferState</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">State structure shared between SDMAK and SDMA user layers.  <a href="struct_s_d_m_a__transfer_state.html#_details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">union &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="union_s_d_m_a__request_dma_params.html">SDMA_requestDmaParams</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">SDMAK ioctl input/output parameters.  <a href="union_s_d_m_a__request_dma_params.html#_details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Descriptor for a channel granted with a SDMA_IOCREQUESTDMA ioctl().  <a href="struct_s_d_m_a___channel_descriptor.html#_details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="define-members"></a>
Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga5a56502b7267c0d282482430b31bafbf">SDMA_VERSION</a>&#160;&#160;&#160;0x01010000U</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga575ba4b089ce068f316ea8f26329731e">SDMA_IOCMAGIC</a>&#160;&#160;&#160;0x0000fb00</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">SDMAK ioctl() commands.  <a href="#ga575ba4b089ce068f316ea8f26329731e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga871606b17c30573afd86ce0eb8aed793">SDMA_IOCCMDMASK</a>&#160;&#160;&#160;0x000000ff</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga3e69a60f4fb4165cf6e9bae183d76e18">SDMA_IOCREQUESTDMA</a>&#160;&#160;&#160;1</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#gaf61056646c5f1f470ad48f25f8bec891">SDMA_IOCRELEASEDMA</a>&#160;&#160;&#160;2</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0233858df32d487eccc7222f177a4535">SDMA_IOCWAITFORCOMPLETION</a>&#160;&#160;&#160;3</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga12b43daa7600cb5eb684874e5a35cb14">SDMA_IOCGETVERSION</a>&#160;&#160;&#160;4</td></tr>
<tr><td colspan="2"><h2><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct <br class="typebreak"/>
<a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#gac90fcbb51fb47d76978a2a43959ea1dc">SDMA_ChannelDescriptor</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Descriptor for a channel granted with a SDMA_IOCREQUESTDMA ioctl().  <a href="#gac90fcbb51fb47d76978a2a43959ea1dc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef enum <a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga4b4405f362573bbae71e5808df1cbe99">SDMA_Status</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Status codes for SDMA API return values.  <a href="#ga4b4405f362573bbae71e5808df1cbe99"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a> { <br/>
&#160;&#160;<a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#gga0320eede22af77d23066c79b98f83d86aaedf16bd0ba00df842dbc025dd670355">SDMA_OK</a> =  0, 
<br/>
&#160;&#160;<a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#gga0320eede22af77d23066c79b98f83d86aed3a0eaeb1a46c9ab4bf9720767675c5">SDMA_EFAIL</a>, 
<br/>
&#160;&#160;<a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#gga0320eede22af77d23066c79b98f83d86ac5fd05a19b35afdb5a7d73c83077dc3a">SDMA_ENOCHANNEL</a>, 
<br/>
&#160;&#160;<a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#gga0320eede22af77d23066c79b98f83d86a5149eca0e66ee63328729ef1fcd78fdd">SDMA_ENOINIT</a>
<br/>
 }</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight"><p>Status codes for SDMA API return values. </p>
 <a href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga2f696c8f6e535ff8b8a50946aa801bc2">SDMA_init</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">SDMA initialization API.  <a href="#ga2f696c8f6e535ff8b8a50946aa801bc2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga8dff87d79d68c1e9a3eb54ca4133ec7c">SDMA_exit</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">SDMA finalization API.  <a href="#ga8dff87d79d68c1e9a3eb54ca4133ec7c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga61ad0de72b29de1788eec637c1930275">SDMA_getChannels</a> (int numChannels, <a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a> chanArray[])</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns available logical channels.  <a href="#ga61ad0de72b29de1788eec637c1930275"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga81c0e872ec8e43abecc801f5da40c6e6">SDMA_freeChannels</a> (int numChannels, <a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a> chanArray[])</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Frees previously requested logical channels.  <a href="#ga81c0e872ec8e43abecc801f5da40c6e6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga3e11eddf1b871b7499a104acefcfb328">SDMA_wait</a> (<a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a> *channel)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Waits for the transfer corresponding to this descriptor to complete.  <a href="#ga3e11eddf1b871b7499a104acefcfb328"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga04c8ced481b3043a8347a9df4fe3a715">SDMA_check</a> (<a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a> *channel, int *pcompleted)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks the status of the transfer corresponding to this descriptor and returns it in the *pcompleted field.  <a href="#ga04c8ced481b3043a8347a9df4fe3a715"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga8565a8d49e15ea9769f1a9c698ed229c">SDMA_getVersion</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve version from SDMA driver.  <a href="#ga8565a8d49e15ea9769f1a9c698ed229c"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>This is the API for the SDMA Manager. </p>
<hr/><h2>Define Documentation</h2>
<a class="anchor" id="ga5a56502b7267c0d282482430b31bafbf"></a><!-- doxytag: member="sdma.h::SDMA_VERSION" ref="ga5a56502b7267c0d282482430b31bafbf" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define SDMA_VERSION&#160;&#160;&#160;0x01010000U</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga575ba4b089ce068f316ea8f26329731e"></a><!-- doxytag: member="sdma.h::SDMA_IOCMAGIC" ref="ga575ba4b089ce068f316ea8f26329731e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define SDMA_IOCMAGIC&#160;&#160;&#160;0x0000fb00</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>SDMAK ioctl() commands. </p>

</div>
</div>
<a class="anchor" id="ga871606b17c30573afd86ce0eb8aed793"></a><!-- doxytag: member="sdma.h::SDMA_IOCCMDMASK" ref="ga871606b17c30573afd86ce0eb8aed793" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define SDMA_IOCCMDMASK&#160;&#160;&#160;0x000000ff</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga3e69a60f4fb4165cf6e9bae183d76e18"></a><!-- doxytag: member="sdma.h::SDMA_IOCREQUESTDMA" ref="ga3e69a60f4fb4165cf6e9bae183d76e18" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define SDMA_IOCREQUESTDMA&#160;&#160;&#160;1</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="gaf61056646c5f1f470ad48f25f8bec891"></a><!-- doxytag: member="sdma.h::SDMA_IOCRELEASEDMA" ref="gaf61056646c5f1f470ad48f25f8bec891" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define SDMA_IOCRELEASEDMA&#160;&#160;&#160;2</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga0233858df32d487eccc7222f177a4535"></a><!-- doxytag: member="sdma.h::SDMA_IOCWAITFORCOMPLETION" ref="ga0233858df32d487eccc7222f177a4535" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define SDMA_IOCWAITFORCOMPLETION&#160;&#160;&#160;3</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga12b43daa7600cb5eb684874e5a35cb14"></a><!-- doxytag: member="sdma.h::SDMA_IOCGETVERSION" ref="ga12b43daa7600cb5eb684874e5a35cb14" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define SDMA_IOCGETVERSION&#160;&#160;&#160;4</td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Typedef Documentation</h2>
<a class="anchor" id="gac90fcbb51fb47d76978a2a43959ea1dc"></a><!-- doxytag: member="sdma.h::SDMA_ChannelDescriptor" ref="gac90fcbb51fb47d76978a2a43959ea1dc" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a>  <a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Descriptor for a channel granted with a SDMA_IOCREQUESTDMA ioctl(). </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The address of the transferState member is passed down to the SDMAK module during the <code>SDMA_IOCREQUESTDMA</code> ioctl(). The SDMAK module maps this address and queries and writes to it during the completion ISR activity. It is therefore vital that the address of the descriptor passed to <code><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga61ad0de72b29de1788eec637c1930275" title="Returns available logical channels.">SDMA_getChannels()</a></code> is in persistent memory that is live for the duration of SDMA channel usage.</dd></dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga61ad0de72b29de1788eec637c1930275" title="Returns available logical channels.">SDMA_getChannels()</a> </dd>
<dd>
<a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga81c0e872ec8e43abecc801f5da40c6e6" title="Frees previously requested logical channels.">SDMA_freeChannels()</a> </dd>
<dd>
<a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga3e11eddf1b871b7499a104acefcfb328" title="Waits for the transfer corresponding to this descriptor to complete.">SDMA_wait()</a> </dd>
<dd>
<a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga04c8ced481b3043a8347a9df4fe3a715" title="Checks the status of the transfer corresponding to this descriptor and returns it in the *pcompleted ...">SDMA_check()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga4b4405f362573bbae71e5808df1cbe99"></a><!-- doxytag: member="sdma.h::SDMA_Status" ref="ga4b4405f362573bbae71e5808df1cbe99" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef enum <a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a>  <a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Status codes for SDMA API return values. </p>

</div>
</div>
<hr/><h2>Enumeration Type Documentation</h2>
<a class="anchor" id="ga0320eede22af77d23066c79b98f83d86"></a><!-- doxytag: member="sdma.h::SDMA_Status" ref="ga0320eede22af77d23066c79b98f83d86" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Status codes for SDMA API return values. </p>
<dl><dt><b>Enumerator: </b></dt><dd><table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" id="gga0320eede22af77d23066c79b98f83d86aaedf16bd0ba00df842dbc025dd670355"></a><!-- doxytag: member="SDMA_OK" ref="gga0320eede22af77d23066c79b98f83d86aaedf16bd0ba00df842dbc025dd670355" args="" -->SDMA_OK</em>&nbsp;</td><td>
<p>OK </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga0320eede22af77d23066c79b98f83d86aed3a0eaeb1a46c9ab4bf9720767675c5"></a><!-- doxytag: member="SDMA_EFAIL" ref="gga0320eede22af77d23066c79b98f83d86aed3a0eaeb1a46c9ab4bf9720767675c5" args="" -->SDMA_EFAIL</em>&nbsp;</td><td>
<p>general failure </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga0320eede22af77d23066c79b98f83d86ac5fd05a19b35afdb5a7d73c83077dc3a"></a><!-- doxytag: member="SDMA_ENOCHANNEL" ref="gga0320eede22af77d23066c79b98f83d86ac5fd05a19b35afdb5a7d73c83077dc3a" args="" -->SDMA_ENOCHANNEL</em>&nbsp;</td><td>
<p>no channels available </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga0320eede22af77d23066c79b98f83d86a5149eca0e66ee63328729ef1fcd78fdd"></a><!-- doxytag: member="SDMA_ENOINIT" ref="gga0320eede22af77d23066c79b98f83d86a5149eca0e66ee63328729ef1fcd78fdd" args="" -->SDMA_ENOINIT</em>&nbsp;</td><td>
<p><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga2f696c8f6e535ff8b8a50946aa801bc2" title="SDMA initialization API.">SDMA_init()</a> not called </p>
</td></tr>
</table>
</dd>
</dl>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ga2f696c8f6e535ff8b8a50946aa801bc2"></a><!-- doxytag: member="sdma.h::SDMA_init" ref="ga2f696c8f6e535ff8b8a50946aa801bc2" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int SDMA_init </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname">&#160;)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>SDMA initialization API. </p>

</div>
</div>
<a class="anchor" id="ga8dff87d79d68c1e9a3eb54ca4133ec7c"></a><!-- doxytag: member="sdma.h::SDMA_exit" ref="ga8dff87d79d68c1e9a3eb54ca4133ec7c" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int SDMA_exit </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname">&#160;)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>SDMA finalization API. </p>

</div>
</div>
<a class="anchor" id="ga61ad0de72b29de1788eec637c1930275"></a><!-- doxytag: member="sdma.h::SDMA_getChannels" ref="ga61ad0de72b29de1788eec637c1930275" args="(int numChannels, SDMA_ChannelDescriptor chanArray[])" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a> SDMA_getChannels </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"> <em>numChannels</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a>&#160;</td>
          <td class="paramname"> <em>chanArray</em>[]&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns available logical channels. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">numChannels</td><td>number of requested channels. </td></tr>
    <tr><td class="paramname">chanArray</td><td>pointer to <a class="el" href="struct_s_d_m_a___channel_descriptor.html" title="Descriptor for a channel granted with a SDMA_IOCREQUESTDMA ioctl().">SDMA_ChannelDescriptor</a> storage of sufficient size to hold numChannels descriptors. All structure array fields are filled by this API (in other words, no fields need to be filled by the caller prior to the call).</td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>chanArray must be allocated from memory that persists over the life of the channel's usage, since the address of the chanArray will be used by the SDMA kernel driver. This implies that the contents of the passed chanArray should not be copied to another <a class="el" href="struct_s_d_m_a___channel_descriptor.html" title="Descriptor for a channel granted with a SDMA_IOCREQUESTDMA ioctl().">SDMA_ChannelDescriptor</a> that is then used for the subsequent operations.</dd>
<dd>
Fails if the requested number of channels is not available.</dd></dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga81c0e872ec8e43abecc801f5da40c6e6" title="Frees previously requested logical channels.">SDMA_freeChannels()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga81c0e872ec8e43abecc801f5da40c6e6"></a><!-- doxytag: member="sdma.h::SDMA_freeChannels" ref="ga81c0e872ec8e43abecc801f5da40c6e6" args="(int numChannels, SDMA_ChannelDescriptor chanArray[])" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a> SDMA_freeChannels </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"> <em>numChannels</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a>&#160;</td>
          <td class="paramname"> <em>chanArray</em>[]&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Frees previously requested logical channels. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">numChannels</td><td>number of requested channels. </td></tr>
    <tr><td class="paramname">chanArray</td><td>pointer to <a class="el" href="struct_s_d_m_a___channel_descriptor.html" title="Descriptor for a channel granted with a SDMA_IOCREQUESTDMA ioctl().">SDMA_ChannelDescriptor</a> storage of sufficient size to hold numChannels descriptors. This will typically be the same pointer passed to <a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga61ad0de72b29de1788eec637c1930275" title="Returns available logical channels.">SDMA_getChannels()</a>.</td></tr>
  </table>
  </dd>
</dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga61ad0de72b29de1788eec637c1930275" title="Returns available logical channels.">SDMA_getChannels()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga3e11eddf1b871b7499a104acefcfb328"></a><!-- doxytag: member="sdma.h::SDMA_wait" ref="ga3e11eddf1b871b7499a104acefcfb328" args="(SDMA_ChannelDescriptor *channel)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a> SDMA_wait </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a> *&#160;</td>
          <td class="paramname"> <em>channel</em>&#160;)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Waits for the transfer corresponding to this descriptor to complete. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">channel</td><td>pointer to the single channel for which to wait.</td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga3e11eddf1b871b7499a104acefcfb328" title="Waits for the transfer corresponding to this descriptor to complete.">SDMA_wait()</a> first checks the transferComplete flag of the struct <a class="el" href="struct_s_d_m_a__transfer_state.html" title="State structure shared between SDMAK and SDMA user layers.">SDMA_transferState</a> in channel. This flag is directly written by the SDMAK module's completion ISR. If this flag is not set to 1, <a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga3e11eddf1b871b7499a104acefcfb328" title="Waits for the transfer corresponding to this descriptor to complete.">SDMA_wait()</a> will issue a <code>SDMA_IOCWAITFORCOMPLETION</code> ioctl(), which will block inside the SDMAK module and become unblocked by the completion ISR.</dd></dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga04c8ced481b3043a8347a9df4fe3a715" title="Checks the status of the transfer corresponding to this descriptor and returns it in the *pcompleted ...">SDMA_check()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga04c8ced481b3043a8347a9df4fe3a715"></a><!-- doxytag: member="sdma.h::SDMA_check" ref="ga04c8ced481b3043a8347a9df4fe3a715" args="(SDMA_ChannelDescriptor *channel, int *pcompleted)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga0320eede22af77d23066c79b98f83d86">SDMA_Status</a> SDMA_check </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct_s_d_m_a___channel_descriptor.html">SDMA_ChannelDescriptor</a> *&#160;</td>
          <td class="paramname"> <em>channel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"> <em>pcompleted</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Checks the status of the transfer corresponding to this descriptor and returns it in the *pcompleted field. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">channel</td><td>pointer to single channel to check. </td></tr>
    <tr><td class="paramname">pcompleted</td><td>pointer to completion status.</td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>copies the contents of the transferComplete flag of the struct <a class="el" href="struct_s_d_m_a__transfer_state.html" title="State structure shared between SDMAK and SDMA user layers.">SDMA_transferState</a> in channel into *pcompleted (does not issue any ioctl()).</dd></dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga3e11eddf1b871b7499a104acefcfb328" title="Waits for the transfer corresponding to this descriptor to complete.">SDMA_wait()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga8565a8d49e15ea9769f1a9c698ed229c"></a><!-- doxytag: member="sdma.h::SDMA_getVersion" ref="ga8565a8d49e15ea9769f1a9c698ed229c" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int SDMA_getVersion </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname">&#160;)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Retrieve version from SDMA driver. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>Installed SDMA driver's version number.</dd></dl>
<dl class="pre"><dt><b>Precondition:</b></dt><dd>Must have called <a class="el" href="group__ti__sdo__linuxutils__sdma___s_d_m_a.html#ga2f696c8f6e535ff8b8a50946aa801bc2" title="SDMA initialization API.">SDMA_init()</a> </dd></dl>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr size="1" /><small>
Copyright  2012, Texas Instruments Incorporated</small>
</body>
</html>
<!--
/*
 * @(#) linuxutils_3_23_00_01; 1, 0, 0,1; 5-30-2012 11:51:36; /db/atree/library/trees/linuxutils/linuxutils-l01/src/ xlibrary

 */
-->

